﻿using System;
using System.Text;
using System.Data;
using HealthyHitsujiWpf.Model.Content;
using HealthyHitsujiWpf.Model.DataBase;

namespace HealthyHitsujiWpf.Model.OutPutFileSetterModel
{
    public class MonthDataAllSetterModel : _IOutPutCsvFileSetterModel
    {

        //出力情報のカラム設定を生成
        public Action<DataTable> buildColumnSelectionDelegate()
        {
            return delegate(DataTable table)
            {
                //table.Columns.Add(new DataColumn(MonthDataBaseColumnModel.day_));
                table.Columns.Add(new DataColumn(MonthDataBaseColumnModel.am_));
                table.Columns.Add(new DataColumn(MonthDataBaseColumnModel.noon_));
                table.Columns.Add(new DataColumn(MonthDataBaseColumnModel.pm_));
                table.Columns.Add(new DataColumn(MonthDataBaseColumnModel.other_));
                table.Columns.Add(new DataColumn(MonthDataBaseColumnModel.balGrain_));
                table.Columns.Add(new DataColumn(MonthDataBaseColumnModel.balMeat_));
                table.Columns.Add(new DataColumn(MonthDataBaseColumnModel.balSeafood_));
                table.Columns.Add(new DataColumn(MonthDataBaseColumnModel.balVegetable_));
                table.Columns.Add(new DataColumn(MonthDataBaseColumnModel.balFruit_));
                table.Columns.Add(new DataColumn(MonthDataBaseColumnModel.balDairy_));
                table.Columns.Add(new DataColumn(MonthDataBaseColumnModel.burn_));
                table.Columns.Add(new DataColumn(MonthDataBaseColumnModel.walk_));
                table.Columns.Add(new DataColumn(MonthDataBaseColumnModel.cm_));
                table.Columns.Add(new DataColumn(MonthDataBaseColumnModel.kg_));
                table.Columns.Add(new DataColumn(MonthDataBaseColumnModel.memo_));
            };
        }


        //出力情報のフィールド設定を生成
        public Action<DataRow, _IContentModel> buildFieldSelectionDelegate()
        {
            return delegate(DataRow row, _IContentModel model)
            {
                DateContentsModel d = (DateContentsModel)model;
                row[MonthDataBaseColumnModel.am_] = d.calAm;
                row[MonthDataBaseColumnModel.noon_] = d.calNoon;
                row[MonthDataBaseColumnModel.pm_] = d.calPm;
                row[MonthDataBaseColumnModel.other_] = d.calOther;
                row[MonthDataBaseColumnModel.balGrain_] = d.balanceGrain;
                row[MonthDataBaseColumnModel.balMeat_] = d.balanceMeat;
                row[MonthDataBaseColumnModel.balSeafood_] = d.balanceSeafood;
                row[MonthDataBaseColumnModel.balVegetable_] = d.balanceVegetable;
                row[MonthDataBaseColumnModel.balFruit_] = d.balanceFruit;
                row[MonthDataBaseColumnModel.balDairy_] = d.balanceDairy;
                row[MonthDataBaseColumnModel.burn_] = d.calBurn;
                row[MonthDataBaseColumnModel.walk_] = d.walkCount;
                row[MonthDataBaseColumnModel.cm_] = d.heightCm;
                row[MonthDataBaseColumnModel.kg_] = d.weightKg;
                row[MonthDataBaseColumnModel.memo_] = d.memo;
            };
        }
    }
}
