﻿using System;
using System.Text;
using System.Data;
using HealthyHitsujiWpf.Model.Content;
using HealthyHitsujiWpf.Model.DataBase;

namespace HealthyHitsujiWpf.Model.OutPutFileSetterModel
{
    public class BalanceDataSetterModel : _IOutPutCsvFileSetterModel
    {
        #region _IOutPutCsvFileSetterModel メンバ

        public Action<DataTable> buildColumnSelectionDelegate()
        {
            return delegate(DataTable table)
            {
                table.Columns.Add(new DataColumn(MonthDataBaseColumnModel.balGrain_));
                table.Columns.Add(new DataColumn(MonthDataBaseColumnModel.balMeat_));
                table.Columns.Add(new DataColumn(MonthDataBaseColumnModel.balSeafood_));
                table.Columns.Add(new DataColumn(MonthDataBaseColumnModel.balVegetable_));
                table.Columns.Add(new DataColumn(MonthDataBaseColumnModel.balFruit_));
                table.Columns.Add(new DataColumn(MonthDataBaseColumnModel.balDairy_));
            };
        }

        public Action<DataRow, _IContentModel> buildFieldSelectionDelegate()
        {
            return delegate(DataRow row, _IContentModel model)
            {
                DateContentsModel d = (DateContentsModel)model;
                row[MonthDataBaseColumnModel.balGrain_] = d.balanceGrain;
                row[MonthDataBaseColumnModel.balMeat_] = d.balanceMeat;
                row[MonthDataBaseColumnModel.balSeafood_] = d.balanceSeafood;
                row[MonthDataBaseColumnModel.balVegetable_] = d.balanceVegetable;
                row[MonthDataBaseColumnModel.balFruit_] = d.balanceFruit;
                row[MonthDataBaseColumnModel.balDairy_] = d.balanceDairy;
            };
        }

        #endregion
    }
}
