﻿using System;
using System.Collections.Generic;
using System.Windows;

namespace HealthyHitsujiWpf.Model.View
{
    public class _AViewModel
    {
        //子要素ViewModelを参照させる
        protected Dictionary<String, _AViewModel> viewModelMembers_ = null;
        public _AViewModel getViewModelMember(String viewModelClassName)
        {
            _AViewModel vm = null;
            foreach (KeyValuePair<String, _AViewModel> kvp in viewModelMembers_)
            {
                if (kvp.Key.Equals(viewModelClassName))
                {
                    vm = kvp.Value;
                    break;
                }
            }
            return vm;
        }

        protected _AViewModel parentVM_;
        public void addMyselfAsViewModelMember(_AViewModel parentVM)
        {
            if (parentVM.viewModelMembers_ == null) parentVM.viewModelMembers_ = new Dictionary<string, _AViewModel>();

            this.parentVM_ = parentVM;
            parentVM.viewModelMembers_.Add(this.GetType().Name, this);
        }


        private Window baseUiWindow_;
        public Window BaseUiWindow
        {
            get
            {
                if (this.baseUiWindow_ != null)
                {
                    return this.baseUiWindow_;
                }
                else
                {
                    return parentVM_.BaseUiWindow;
                }
            }
            set { baseUiWindow_ = value; }
        }
    }
}
